%define mod_version 1.1.17

%define xsp_mod_version %mod_version
%define module_path %{_libdir}/apache-extramodules
%define module_name mod_mono

Summary:	Mono module for Apache 2
Name:		apache-mod_mono
Version:	%{mod_version}
Release:	%mkrel 3
License:	Apache License
Group:		System/Servers
URL:		http://www.mono-project.com/downloads/
Source0:	http://www.go-mono.com/sources/mod_mono/%{module_name}-%{mod_version}.tar.bz2
Source1:	http://www.go-mono.com/sources/xsp/xsp-%{xsp_mod_version}.tar.bz2
Patch0:		mod_mono-1.0.4-avoid-version.diff
Patch1:		mod_mono-1.1.17-apache223.patch.bz2
Requires(pre): rpm-helper
Requires(postun): rpm-helper
Requires(pre):	apache-conf >= 2.2.0
Requires(pre):	apache >= 2.2.0
Requires:	apache-conf >= 2.2.0
Requires:	apache >= 2.2.0
BuildRequires:	apache-devel >= 2.2.0
BuildRequires:	mono-devel
BuildRequires:	automake1.7
BuildRequires:	autoconf2.5
BuildRequires:  file
Requires:	mono
BuildRequires:	file
Provides:	apache2-mod_mono
Obsoletes:	apache2-mod_mono
Epoch:		1
BuildRoot:	%{_tmppath}/%{name}-%{version}-root

%description
This is an experimental module that allows you to run ASP.NET
pages on Unix with Apache and Mono.
It includes some aspx C# scripts for testing.
Please read the included INSTALL file for how to get the mod-mono
server running.

%prep

%setup -q -n %{module_name}-%{mod_version} -a 1
%patch0 -p0
%patch1 -p1 -b .apache223

%build
export WANT_AUTOCONF_2_5=1
rm -f configure
libtoolize --copy --force; aclocal-1.7; automake-1.7 --add-missing --copy; autoconf --force

# Build sample ASP.NET pages from xsp distribution
pushd xsp-%{xsp_mod_version}
%configure2_5x
make
popd

# Build Apache Module
export CPPFLAGS="`apr-1-config --cppflags`"
%configure2_5x \
    --with-apxs=%{_sbindir}/apxs \
    --with-apr-config=%{_bindir}/apr-1-config
make

%install
rm -fr %{buildroot}

pushd xsp-%{xsp_mod_version}
%makeinstall_std
%if %_lib != lib
mv %buildroot%_libdir/xsp/* %buildroot%_prefix/lib/xsp
%endif
popd

install -d 755 %{buildroot}%{_sysconfdir}/httpd/modules.d
install -d 755 %{buildroot}%{module_path}
install -d 755 %{buildroot}%{_var}/www/mono
install -d 755 %{buildroot}%{_var}/www/.wapi

# Mono Configuration for Apache
cat > %{buildroot}%{_sysconfdir}/httpd/modules.d/91_mod_mono.conf << EOF
AddType application/x-asp-net .aspx .ashx .asmx .ascx .asax .config .ascx
LoadModule mono_module extramodules/mod_mono.so
MonoUnixSocket /tmp/mod_mono_server
Listen 8080
Alias /mono "%{_defaultdocdir}/%{name}-%{mod_version}/test"
EOF

install src/.libs/mod_mono.so %{buildroot}%{module_path}/mod_mono.so
install -D man/mod_mono.8 %{buildroot}%{_mandir}/man8/mod_mono.8

# strip away annoying ^M
find %{buildroot} -type f|xargs file|grep 'CRLF'|cut -d: -f1|xargs perl -p -i -e 's/\r//'
find %{buildroot} -type f|xargs file|grep 'text'|cut -d: -f1|xargs perl -p -i -e 's/\r//'

%post
if [ -f %{_var}/lock/subsys/httpd ]; then
    %{_initrddir}/httpd restart 1>&2;
fi
    
%postun
if [ "$1" = "0" ]; then
    if [ -f %{_var}/lock/subsys/httpd ]; then
	%{_initrddir}/httpd restart 1>&2
    fi
fi
		    
%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}
		    
%files
%defattr(-,root,root)
%doc ChangeLog COPYING INSTALL NEWS README xsp-%{xsp_mod_version}/test
%attr(0755,root,root) %{_bindir}/*
%attr(0644,root,root) %config(noreplace)  %{_sysconfdir}/httpd/modules.d/91_mod_mono.conf
%attr(0755,root,root) %{module_path}/mod_mono.so
%attr(0644,root,root) %{_mandir}/man1/*
%attr(0644,root,root) %{_mandir}/man8/mod_mono.8*
%_libdir/pkgconfig/*
%_prefix/lib/xsp
%_prefix/lib/mono/?.0/*
%_prefix/lib/mono/gac/*
%defattr(-,apache,apache)
%dir %{_var}/www/mono
%dir %{_var}/www/.wapi

%changelog
* Mon Sep 11 2006 Gtz Waschk <waschk@mandriva.org> 1.1.17-3mdv2007.0
- rediff patch 1
- new version

* Wed Aug 30 2006 Gtz Waschk <waschk@mandriva.org> 1.1.16.1-3mdv2007.0
- update file list
- update xsp to 1.1.17

* Fri Aug 04 2006 Oden Eriksson <oeriksson@mandriva.com> 1:1.1.16.1-2mdv2007.0
- make it actually work with apache-2.2.3 (P1)

* Thu Aug 03 2006 Oden Eriksson <oeriksson@mandriva.com> 1:1.1.16.1-1mdk
- 1.1.16.1

* Wed Jan 11 2006 Oden Eriksson <oeriksson@mandrakesoft.com> 1:1.13-1mdk
- 1.13
- fix versioning
- added P1,P2 to teach it apache 2.2

* Wed Jan 11 2006 Gtz Waschk <waschk@mandriva.org> 2.0.55_1.1.13-1mdk
- fix configure for new apr
- new version

* Mon Dec 12 2005 Gtz Waschk <waschk@mandriva.org> 2.0.55_1.1.10.1-1mdk
- new version

* Mon Dec  5 2005 Gtz Waschk <waschk@mandriva.org> 2.0.55_1.1.10-3mdk
- fix xsp location

* Mon Dec  5 2005 Gtz Waschk <waschk@mandriva.org> 2.0.55_1.1.10-2mdk
- update mod_mono tarball

* Wed Nov  9 2005 Gtz Waschk <waschk@mandriva.org> 2.0.55_1.1.10-1mdk
- update file list
- new version

* Wed Oct 12 2005 Gtz Waschk <waschk@mandriva.org> 2.0.54_1.1.9.2-1mdk
- new version

* Fri Sep 23 2005 Gtz Waschk <waschk@mandriva.org> 2.0.54_1.1.9.1-1mdk
- New release 1.1.9.1

* Tue Sep 13 2005 Gtz Waschk <waschk@mandriva.org> 2.0.54_1.1.9-2mdk
- rebuild

* Sat Sep 10 2005 Gtz Waschk <waschk@mandriva.org> 2.0.54_1.1.9-1mdk
- add new files
- drop patch 1
- New release 1.1.9

* Sat Jul 30 2005 Oden Eriksson <oeriksson@mandriva.com> 2.0.54_1.0.9-2mdk
- fix deps

* Thu Jun 02 2005 Oden Eriksson <oeriksson@mandriva.com> 2.0.54_1.0.9-1mdk
- rename the package
- the conf.d directory is renamed to modules.d
- use new rpm-4.4.x pre,post magic

* Mon May  9 2005 Gtz Waschk <waschk@mandriva.org> 2.0.53_1.0.9-1mdk
- New release 1.0.9

* Fri Apr 22 2005 Gtz Waschk <waschk@mandriva.org> 2.0.53_1.0.8-1mdk
- new version

* Sun Mar 20 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_1.0.6-3mdk
- use the %%mkrel macro

* Mon Feb 28 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_1.0.6-2mdk
- fix %%post and %%postun to prevent double restarts
- fix bug #6574

* Sun Feb 20 2005 Gtz Waschk <waschk@linux-mandrake.com> 2.0.53_1.0.6-1mdk
- fix build
- New release 1.0.6

* Wed Feb 16 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_1.0.5-3mdk
- spec file cleanups, remove the ADVX-build stuff

* Mon Feb 14 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_1.0.5-2mdk
- new url
- strip away annoying ^M

* Tue Feb  8 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_1.0.5-1mdk
- rebuilt for apache 2.0.53
- fix versioning
- misc spec file fixes

* Thu Dec  9 2004 Gtz Waschk <waschk@linux-mandrake.com> 1.0.5-1mdk
- fix installation
- New release 1.0.5

* Tue Nov 23 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0.4-3mdk
- make it compile on 10.0 too
- added P0

* Tue Nov 09 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0.4-2mdk
- rebuilt for apache 2.0.52

* Fri Nov  5 2004 Goetz Waschk <waschk@linux-mandrake.com> 1.0.4-1mdk
- New release 1.0.4

* Wed Sep 22 2004 Gtz Waschk <waschk@linux-mandrake.com> 1.0.2-1mdk
- fix build and installation
- fix source URLs
- New release 1.0.2

* Wed Aug 11 2004 Gtz Waschk <waschk@linux-mandrake.com> 1.0.1-1mdk
- new mod_version

* Mon Jul 19 2004 Gtz Waschk <waschk@linux-mandrake.com> 1.0-1mdk
- fix configure calls
- New release 1.0

* Mon Feb 16 2004 Marcel Pol <mpol@mandrake.org> 0.7-2mdk
- fix description

* Sun Feb 08 2004 Marcel Pol <mpol@mandrake.org> 0.7-1mdk
- 0.7, it even works now
- require mono
- from Quel Qun <kelk1@hotmail.com>
    - drop source2, generate inside specfile
    - several spec changes

* Tue Aug 05 2003 Marcel Pol <mpol@gmx.net> 0.3.7-3mdk
- build for apache 2.0.47
- own dir

* Sat Jun 07 2003 Marcel Pol <mpol@gmx.net> 0.3.7-2mdk
- build for apache 2.0.46

* Tue May 13 2003 Marcel Pol <mpol@gmx.net> 0.3.7-1mdk
- 0.3.7

* Fri Apr 25 2003 Marcel Pol <mpol@gmx.net> 0.3.6-2mdk
- autoconf2.5
- build for apache 2.0.45

* Sun Mar 23 2003 Marcel Pol <mpol@gmx.net> 0.3.6-1mdk
- src.rpm from Quel Qun <kelk1@hotmail.com>
- more informative description

* Mon Feb 03 2003 Daniel Lopez Ridruejo <daniel @ rawbyte.com>
- Use --with-apxs
- License is Apache-style
- Change ownership to apache user
- Create .wapi directory
* Mon Feb 03 2003 David Hollis <dhollis@davehollis.com>
- 0.3.4
* Wed Jan 15 2003 David Hollis <dhollis@davehollis.com>
- Initial spec
